#ifndef _SYS_SELECT_H
#define _SYS_SELECT_H
#ifdef __STDC__
#pragma comment(exestr, "@(#) select.h 25.1 92/07/31 ")
#else
#ident "@(#) select.h 25.1 92/07/31 "
#endif
/*
 *	Copyright (C) 1988-1992 The Santa Cruz Operation, Inc.
 *		All Rights Reserved.
 *	The information in this file is provided for the exclusive use of
 *	the licensees of The Santa Cruz Operation, Inc.  Such users have the
 *	right to use, modify, and incorporate this code into other products
 *	for purposes authorized by the license agreement provided they include
 *	this notice and the associated copyright notice with any such product.
 *	The information in this file is provided "AS IS" without warranty.
 */

/*
 * THIS FILE CONTAINS CODE WHICH IS DESIGNED TO BE
 * PORTABLE BETWEEN DIFFERENT MACHINE ARCHITECTURES
 * AND CONFIGURATIONS. IT SHOULD NOT REQUIRE ANY
 * MODIFICATIONS WHEN ADAPTING XENIX TO NEW HARDWARE.
 */

/*
 * Code used internally for select system call.
 */
#define IOC_SELECT	0xffff

/*
 * Selectable conditions for select system call
 */
#define	SELREAD		0x1
#define	SELWRITE	0x2
#define	SELEXCEPT	0x4

#ifndef _INKERNEL
#ifdef _NO_PROTOTYPE
extern int select();
#else
#include <sys/types.h>
#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
extern int select(int, fd_set *, fd_set *, fd_set *, struct timeval *);
#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* _NO_PROTOTYPE */
#endif /* !_INKERNEL */

#endif	/* _SYS_SELECT_H */
